# `sample_trie_e_access_traits` Interface

A sample trie element-access traits.

This class serves to show the interface an element- access traits class needs to support.

Defined in: `sample_trie_e_access_traits.hpp`

## Public Types and Constants

### General definitions.

Type | Definition | Description

    size_type

    size_t, e.g.

Size type.

    key_type

    std::string, e.g.

Key type.

    const_key_reference

    const string &, e.g.

Const key reference type.

### Element definitions.

Type | Definition | Description

    const_iterator

    string::const_iterator, e.g.

Element `const` iterator type.

    e_type

    char, e.g.

Element type.

    max_size

    4, e.g.

Number of distinct elements.

## Public Methods

### Access methods.

Method | Description

    inline static const_iterator
      begin
      (const_key_reference r_key)

Returns a `const_iterator` to the first element of `r_key`.

    inline static const_iterator
      end
      (const_key_reference r_key)

Returns a `const_iterator` to the after-last element of `r_key`.

    inline static size_type
      e_pos
      (e_type e)

Maps an `element` to a position.